import processing.video.*;

	// global variables
	Capture camara;
        String camname = "Sony HD Eye for PS3 (SLEH 00201)";
        
        int MOVIE_ENABLE = 1;
        
        boolean locked = false;
        boolean ok = false;
        boolean onCalibrate = true;
        int numcores = 0;

        
	int[] screensize = { 800, 600 };

        ArrayList cores = new ArrayList();
        ArrayList usedColors = new ArrayList();
        color trackColor;
        color[] colors = new color[8];
        
	// Sensitivity. The higher the better. Set these up on setup()
	int volumeSensitivity; // sensitivity for volume.
	int stereoSensitivity; // sensitivity for stereo sound. Use odd numbers

	Area[] screenAreas;
        RectButton rect1;
        color currentcolor;
        boolean startplaying;
        PImage b;
        int num_matches;
        boolean done = false;
        boolean click = false;
        int clicks = 0;

              
        Movie movie;
        boolean movie_flag = false;


	void setup() {

		size(screensize[0], screensize[1]+100);
                camara = new Capture(this, screensize[0], screensize[1], camname,60);
                //camara = new Capture(this, screensize[0], screensize[1], 60);
                //camara.settings();
                
                b = loadImage("ok.png");
	        stroke(0, 0, 0);
                strokeWeight(6);
                //3 segundos para lockar as areas
                num_matches = 0;
                
                movie = new Movie(this,"Colors.m4v");
                if(MOVIE_ENABLE == 1)
                  movie.play();
                
                

              // Define and create rectangle button
                color buttoncolor = color(200,200,200);
                color highlight = color(100,100,100);
                rect1 = new RectButton(350, 605, 100, buttoncolor, highlight);

		volumeSensitivity = 3;
		stereoSensitivity = 3;

		// number of Areas that'll be on screen
		int n = volumeSensitivity * stereoSensitivity;
		screenAreas = new Area[n];


                //copiar as cores...
                for(int i = 0; i<colors.length; i++){
                    colors[i] = color(0,0,0);
                    cores.add(new Cor(colors[i]));}
                

		// calculate the relative stereo level of each area.
		int[] stereos = calculateStereo();

		// determine the screen coordinates of an area's upper left corner
		// and initiate every Area object
		int g = 0;
		int pos_y = 0;
		int y = 0;
		for (int vol = volumeSensitivity; vol > 0; vol--) {

			for (int x = 0; x < stereoSensitivity; x++) {
				int pos_x = (x * screensize[0] / stereoSensitivity);
				screenAreas[g] = new Area(g, vol, stereos[g % stereos.length],
						pos_x, pos_y);
				g++;
			}
			y++;
			pos_y = y * screensize[1] / volumeSensitivity;
		}
              randomTint();
	}
        
        void keyPressed() {
          // Save color where the mouse is clicked in trackColor variable
          if(onCalibrate == true){
            int loc = mouseX + mouseY*camara.width;
            trackColor = camara.pixels[loc];
            this.ok = true;
          }
        }

	void draw() {

		background(0, 0, 0);
                
		if (camara.available()) {
			camara.read();
		}
                loadPixels();
                camara.pixels = reverse(camara.pixels);          
		image(camara, 0, 0);
                    


                if(onCalibrate == true){
                  
                  movie.stop();
                  
                  fill(255,0,0);
                  text("Calibration Mode",330,625);                  
                  String[] nomes = {"Red", "Green", "Blue", "Yellow", "Pink", "Purple", "Brown", "Orange" };
                  String s = "Press any key on "+nomes[numcores];                   
                  printString(s);
                         
                     if(this.ok == true){
                       this.colors[numcores] = trackColor;
                       this.ok = false;
                       numcores++;
                     } 
                  
                  if(numcores == 8 )
                    onCalibrate = false;  

                }//FIM CALIBRACAO
                
                //MAIN STUFF
                else{   
                  
                //acabamos? se sim, ok nao mostrar nada
                if(num_matches == 8){
                    //println("SUCESSO!");
                    this.done = true;
                    fill(0,0,0);
                    rect(0,0,800,600);
                    image(b, 0,0,800,600);
                    
                    update(mouseX, mouseY);
                    rect1.update();
                    rect1.display();
                    
                    fill(0,0,0);
                    text("Recomeçar",367,625);
                    if(this.click == true){
                          this.done = false;
                          this.num_matches = 0;
                          this.click = false;
                     }
                    
                 }

                if(this.done != true){  
                    num_matches = 0;
                    this.click = false;                    

                    //pintar as areas
                    Cor obj;
                    int index = 1;
      		    for (int i = 0; i < screenAreas.length; i++) {
      			Area a = screenAreas[i];
      			a.getColor();
      		    }         
      		    for(int i = 0; i<screenAreas.length; i++){
    			if(i != 4){                    
                                    obj = (Cor) usedColors.get(usedColors.size()-index);
      				screenAreas[i].setColor(obj.getColor());
                                    index++;
    			}
    		    }

                //desenhar botao                  
                update(mouseX, mouseY);
                rect1.update();
                rect1.display();
                 
                //printar info
      		drawLines();
                    
                    //se tem match, desenha a preto 
                    for(int i =0; i<screenAreas.length; i++){
                      if( screenAreas[i].has_match == true &&i != 4 ){
                        num_matches++;
                        fill(0,0,0);
                        rect(screenAreas[i].x,screenAreas[i].y,screenAreas[i].area_x,screenAreas[i].area_y);
                        image(b, screenAreas[i].x,screenAreas[i].y,screenAreas[i].area_x,screenAreas[i].area_y);                    
                        }  
                     }

                  if(MOVIE_ENABLE == 1 && this.clicks >=1){
                  //detectou cor no meio. tocar....
                  //vermelho
                  if(screenAreas[4].best == 0 && screenAreas[4].cor_nome != "..."){
                                    if(movie.time() >= 72)
                                      movie_flag = false;  
                                    if(movie_flag==false){
                                        movie.jump(2);
                                        movie_flag = true;
                                    }
                                      
                                    movie.read();
                                    image(movie,0,0,800,600);
                  }
                  //verde
                  else if(screenAreas[4].best == 1 && screenAreas[4].cor_nome != "..."){
                                    if(movie.time() >= 163)
                                      movie_flag = false;
                                    if(movie_flag==false){
                                        movie.jump(73);
                                        movie_flag = true;
                                    }
                                    movie.read();
                                    image(movie,0,0,800,600);
                  }
                  //azul
                  else if(screenAreas[4].best == 2 && screenAreas[4].cor_nome != "..."){
                                    if(movie.time() >= 249)
                                      movie_flag = false;
                                    if(movie_flag==false){
                                        movie.jump(164);
                                        movie_flag = true;
                                    }
                                    movie.read();
                                    image(movie,0,0,800,600);
                  }
                  //amarelo
                  else if(screenAreas[4].best == 3 && screenAreas[4].cor_nome != "..."){
                                    if(movie.time() >= 336 )
                                      movie_flag = false;
                                    if(movie_flag==false){
                                        movie.jump(250);
                                        movie_flag = true;
                                    }
                                    movie.read();
                                    image(movie,0,0,800,600);
                  }
                  //rosa
                  else if(screenAreas[4].best == 4 && screenAreas[4].cor_nome != "..."){
                                    if(movie.time() >= 426)
                                      movie_flag = false;
                                    if(movie_flag==false){
                                        movie.jump(338);
                                        movie_flag = true;
                                    }
                                    movie.read();
                                    image(movie,0,0,800,600);
                  }
                  //roxo
                  else if(screenAreas[4].best == 5 && screenAreas[4].cor_nome != "..."){
                                    if(movie.time() >=516 )
                                      movie_flag = false;
                                    if(movie_flag==false){
                                        movie.jump(428);
                                        movie_flag = true;
                                    }
                                    movie.read();
                                    image(movie,0,0,800,600);
                  }
                  //castanho
                  else if(screenAreas[4].best == 6 && screenAreas[4].cor_nome != "..."){
                                    if(movie.time() >= 606 )
                                      movie_flag = false;
                                    if(movie_flag==false){
                                        movie.jump(518);
                                        movie_flag = true;
                                    }
                                    movie.read();
                                    image(movie,0,0,800,600);
                  }
                  //laranja
                  else if(screenAreas[4].best == 7 && screenAreas[4].cor_nome != "..."){
                                    if(movie.time() >= 684)
                                      movie_flag = false;
                                    if(movie_flag==false){
                                        movie.jump(608);
                                        movie_flag = true;
                                    }
                                    movie.read();
                                    image(movie,0,0,800,600);
                  }
                  
  
                  else{
                      movie.stop();
                      movie_flag = false;
                      }
                  }//fim movie enable
                }//fim if not done...           
            }//fim else main cycle
	  }
        
           
        void update(int x, int y)
        {
          if(locked == false) {
            rect1.update();
          } 
          else {
            locked = false;
          }
        
          if(mousePressed) {
            if(rect1.pressed()) {
              this.clicks++;
              currentcolor = rect1.basecolor;
              reColor();
              
//              pintar as areas
                Cor obj;
                int index = 1;
  		for(int i = 0; i<screenAreas.length; i++){
			if(i != 4){                    
                                obj = (Cor) usedColors.get(usedColors.size()-index);
  				screenAreas[i].setColor(obj.getColor());
                                index++;
			}
		} 
            } 
          }
        }
        
        void printString(String s){
                fill(255,255,255);
                text(s,320,645);
        }

	void printToScreen() {
                fill(color(0,0,0));
                text("  Começar",367,625);
                fill(color(255,255,255));
		int coordx = 5;
		int coordy = 645;
		int count = 0;
		for(int i =0; i< screenAreas.length;i++){
			if(count%3==0)
				coordy += 12;
			text(screenAreas[i].toString(), screenAreas[i].x, coordy, screenAreas[i].area_x, screenAreas[i].area_y);
			count++;
		}
			
		
	}

	void randomTint(){

		int n = int(random(cores.size()));		
                int maximo = cores.size();
                Cor argh;
                while(usedColors.size()<maximo){
                     argh = (Cor) cores.get(n);
                     usedColors.add(argh);
                     cores.remove(n);                     
                     n = int(random(cores.size()));
                }                
	}

        void reColor(){
          //println("Recomeçar Cores...");
          cores.clear();
          usedColors.clear();
          this.click = true;
          cores = new ArrayList();
          usedColors = new ArrayList();
          //copiar as cores...
          for(int i = 0; i<colors.length; i++)
              cores.add(new Cor(colors[i]));
         
          randomTint(); 
        }

	// function for drawing the various sensitivity lines on screen
	void drawLines() {
        fill(0,0,0);
        text("  Começar",367,625);
	stroke(0, 0, 0);
        strokeWeight(6);
       
       		for (float i = stereoSensitivity; i > 0; i--) {
			line((i * screensize[0]) / stereoSensitivity, 0, i * screensize[0]
					/ stereoSensitivity, screensize[1]);
		}

		// draw lines for volume
		stroke(0, 0, 0);
		for (int i = volumeSensitivity; i > 0; i--) {
			line(0, i * screensize[1] / volumeSensitivity, screensize[0], i
					* screensize[1] / volumeSensitivity);
		}
	}


	// calculates and returns the relative stereo positions of a screen
	// 0 is centre
	// negative number is left
	// positive number is right
	int[] calculateStereo() {

		int[] arr = new int[stereoSensitivity];
		int x = round(stereoSensitivity / 2);

		int i = 0;
		for (i = 0; i < x; i++)
			arr[i] = i;

		int pos = i;
		i = i * (-1);
		i++;

		for (int j = i; j < 0; j++, pos++)
			arr[pos] = j;

		return sort(arr);
	}

        public class Cor{
          color c;
        
          Cor(color c){
           this.c = c;
           }
          
           public color getColor(){
             return this.c;
           } 
        }

	// class representing a particular area on screen
	public class Area {
		int num;
		int volumeLevel;
		int stereoLevel;
		int x;
		int y;
                int best;   //so e usado na area central para sabermos qual o index da cor com melhor match para tocar video

		PImage p;
		color cor;
                color cor_esperada;
                String cor_nome;
                boolean has_match;

		int area_x = screensize[0] / stereoSensitivity;
		int area_y = screensize[1] / volumeSensitivity;
                float nhe;
                float r;
                float g;
                float b;
                
		
		// construtor
		Area(int number, int volume, int stereo, int x, int y) {
			num = number;
			volumeLevel = volume;
			stereoLevel = stereo;
			this.x = x;
			this.y = y;
                        this.nhe = 0;
                        best = 666;
			area_x = screensize[0] / stereoSensitivity;
			area_y = screensize[1] / volumeSensitivity;
			p = get(x, y, area_x, area_y);
                        has_match = false;
		}


		void setColor(color cor) {
                        this.cor_esperada=cor;
			fill(cor, 220);
			rect(this.x, this.y, this.area_x, this.area_y);

		}

		void getColor() {
			p = get(x, y, area_x, area_y);
			p.loadPixels();
                        this.cor_nome = getImageColor(this.p);
		}

		String toString() {
			return "Color " + this.cor_nome + " D: "+this.nhe;
		}
	

                String getImageColor(PImage p){
          
                // get the average values
                        loadPixels();
		        int re = int(red(p.get(p.width/2,p.height/2)));
			int gr = int(green(p.get(p.width/2,p.height/2)));
			int bl = int(blue(p.get(p.width/2,p.height/2)));
			
			float avg_r = re;
			float avg_g = gr;
			float avg_b = bl; 
                        this.r = avg_r;
                        this.g = avg_g;
                        this.b = avg_b;

                        this.cor = color(this.r,this.g,this.b);
                        //guardar proximidade a cor...
			float d = 0;
			float d2 = 0;
                        float d3 = 0;
                        // Before we begin searching, the "world record" for closest color is set to a high number that is easy for the first pixel to beat.
                        float worldRecord = 500;
                        float low = 0;
                        int margem = 40;
                        
                        //se nao e a area do meio...
                         if(this.num != 4){
                             d = dist(avg_r, avg_g, avg_b,                       red(this.cor_esperada),green(this.cor_esperada),blue(this.cor_esperada));
                             d2 = dist(avg_r+margem, avg_g+margem, avg_b+margem, red(this.cor_esperada),green(this.cor_esperada),blue(this.cor_esperada));
                             d3 = dist(avg_r-margem, avg_g-margem, avg_b-margem, red(this.cor_esperada),green(this.cor_esperada),blue(this.cor_esperada));
                             if(d<d2 && d<d3)
                            low = d;
                            else if (d2<d3 && d2<d)
                                low = d2;
                            else
                                low = d3;    

                            if (low < worldRecord) {
                              worldRecord = low;
                              nhe = worldRecord;
                            }
                            
                            //ha match
                            if (worldRecord < 50) { 
                              this.has_match= true;
                              return "MATCH";
                            }
                         }
                         //se e a area do meio temos que ver todas as cores possiveis para identificar o video
                         else{

                             for(int i = 0; i<colors.length; i++){
                              d  = dist(avg_r, avg_g, avg_b,                      red(colors[i]),green(colors[i]),blue(colors[i]));
                              d2 = dist(avg_r+margem, avg_g+margem, avg_b+margem, red(colors[i]),green(colors[i]),blue(colors[i]));
                              d3 = dist(avg_r-margem, avg_g-margem, avg_b-margem, red(colors[i]),green(colors[i]),blue(colors[i]));
                                  
                                  if(d<d2 && d<d3)
                                        low = d;
                                  else if (d2<d3 && d2<d)
                                        low = d2;
                                  else
                                        low = d3;
   
        
                                  if (low < worldRecord) {
                                      worldRecord = low;
                                      nhe = worldRecord;
                                      best = i;
                                  }
                                  if (worldRecord < 50) { 
                                    this.has_match= true;
                                    return "MATCH";
                                  } 
                             }
                             
                         }  
                        
                        
                        //nao ha match
                        this.has_match= false;
			return "...";
        }
}//FIM CLASSE

//###### CLASSES PARA OS BOTOES       
        
        class Button
        {
          int x, y;
          int size;
          color basecolor, highlightcolor;
          color currentcolor;
          boolean over = false;
          boolean pressed = false;   
        
          void update() 
          {
            if(over()) {
              currentcolor = highlightcolor;
            } 
            else {
              currentcolor = basecolor;
            }
          }
        
          boolean pressed() 
          {
            if(over) {
              locked = true;
              return true;
            } 
            else {
              locked = false;
              return false;
            }    
          }
        
          boolean over() 
          { 
            return true; 
          }
        
          boolean overRect(int x, int y, int width, int height) 
          {
            if (mouseX >= x && mouseX <= x+width && 
              mouseY >= y && mouseY <= y+height) {
              return true;
            } 
            else {
              return false;
            }
          }
        
          boolean overCircle(int x, int y, int diameter) 
          {
            float disX = x - mouseX;
            float disY = y - mouseY;
            if(sqrt(sq(disX) + sq(disY)) < diameter/2 ) {
              return true;
            } 
            else {
              return false;
            }
          }
        
        }
        
        class RectButton extends Button
        {
          RectButton(int ix, int iy, int isize, color icolor, color ihighlight) 
          {
            x = ix;
            y = iy;
            size = isize;
            basecolor = icolor;
            highlightcolor = ihighlight;
            currentcolor = basecolor;
          }
        
          boolean over() 
          {
            if( overRect(x, y, size, size) ) {
              over = true;
              return true;
            } 
            else {
              over = false;
              return false;
            }
          }
        
          void display() 
          {
            stroke(255);
            fill(currentcolor);
            rect(x, y, size, size/3);
          }
        }
